<template>
  <frame :modal="modal" position="center" dimmed>
    <div class="">
      <calendar class="px-6 pt-4" @date-click="dateClick($event)" :value="value" />

      <actions>
        <button @click="submitClick()" class="button">Done</button>
        <button @click="modal.hide()" class="text-button text-gray-800">Cancel</button>
      </actions>
    </div>
  </frame>
</template>

<script lang="ts">
import { isModal } from "@/use/modal";
import { DateTime } from "luxon";
import { computed, ref } from "vue";
import Calendar from "@/components/Calendar.vue";

export default {
  components: {
    Calendar
  },
  mixins: [isModal()],
  emits: ["input"],
  props: {
    value: {
      type: DateTime,
      required: false
    },
    title: {
      type: String,
      default: "Select date"
    },
    confirm: {
      type: Boolean,
      default: true
    }
  },
  setup(props, context) {
    const currentMonth = ref(DateTime.local());

    const temporaryValue = ref<DateTime | null>(null);
    const value = computed(() => temporaryValue.value || (props.value as DateTime));

    const submitValue = (value: DateTime) => {
      context.emit("input", value);
      props.modal.hide();
    };

    return {
      value,
      currentMonth,
      dateClick: (date: DateTime) => {
        temporaryValue.value = date;
      },
      submitClick: () => submitValue(value.value)
    };
  }
};
</script>
